# Глоссарий
## Общие сведения
Данный документ содержит список терминов и их определений для основных программных компонентов и понятий, которые используются в Picodata. У глоссария две простые цели:

- Дать точное и непротиворечивое определение каждому термину применительно к его использованию в Picodata.
- Обеспечить единообразие терминологии во внутренних документах (комментарии в коде, readme и прочие Markdown-документы в наших репозиториях).

Список ниже будет дополняться и исправляться в течение времени.

## Список терминов и определений
**Инстанс** — программный узел, входящий в состав кластера. Каждый инстанс является экземпляром приложения Picodata, а также репликой в составе репликасета. Среда выполнения приложения может быть как виртуальной, так и физической.

**Кластер** — набор программных узлов, составляющих отдельную группу.

**Raft** — алгоритм синхронной репликации, обеспечивающий целостность кластера (raft-группы). Raft отвечает за автоматический выбор лидера raft-группы (лидер может меняться). В raft-группе есть лидер, а остальные узлы называются follower’ами.

**Отказоустойчивость** — повышение надежности данных с помощью репликации.

**Репликация** — создание и поддержание в актуальном состоянии резервных копий инстансов.

**Фактор репликации** — число инстансов в репликасете.

**Репликасет** — буквально «набор реплик», экземпляров приложений, в которых хранится один и тот же набор реплицированных данных. В зависимости от роли реплик, в Picodata есть реплики _active (RW)_ и _standby (RO)_. 

**Failure domain** — букв. _"домен отказа"_. Термин обозначает зону доступности инстанса Picodata, т.е. признак физического размещения сервера, на котором запущен инстанс (географический регион, датацентр, стойка и т.д.). Зона доступности используется для того чтобы в один репликасет по возможности попадали инстансы с разным размещением, повышая таким образом отказоустойчивость как отдельного репликасета, так и кластера в целом.

**Bucket** (бакет) — виртуальная неделимая единица хранения данных, обеспечивающая локальность данных (т. е. их нахождение на каком-то одном репликасете).

**Горизонтальное масштабирование** — шардинг, т.е. распределение bucket'ов между различными репликасетами, находящихся на разных серверах. Каждый такое репликасет называется шардом.

**Discovery** — алгоритм взаимного обнаружения инстансами друг друга во время объединения в кластер.

**Space** (спейс) — пространство хранения данных в СУБД. В резидентных СУБД спейс является синонимом _таблицы_ из реляционных СУБД.

**Grade** (грейд) — специфичный для Picodata способ обозначения состояния инстанса. Грейд отражает то, как инстанс сконфигурирован его соседями. Существуют _текущий_ (current) и _целевой_ (target) типы грейдов. За приведение первого ко второму отвечает _governor_ (губернатор).

**Governor** (губернатор) — внутренняя централизованная сущность, управляющая конфигурациями и жизненными циклами инстансов в соответствие с изменениями их грейдов.
